#    dicing.tcl v1.0.1

bind dcc n dicing ::dicing::dccadm

proc dccadm { hand idx arg } {
	switch [lindex $arg 0] {
		give { dccgive $hand $idx [lrange $arg 1 end] }
		take { dcctake $hand $idx [lrange $arg 1 end] }
		pass { dccpass $hand $idx [lrange $arg 1 end] }
		score { dccscore $hand $idx [lrange $arg 1 end] }
		number { dccnumber $hand $idx [lrange $arg 1 end] }
		default {
			putdcc $idx " '.help dicing'";return
		}
	}
}

proc dccnumber { hand idx arg } {
	variable number
	if { [isnumber $arg] && ( $arg >= 1 && $arg <= 12 ) } {
		set number $arg
		putdcc $idx "       $arg"
	} else {
		putdcc $idx "   : $number"
	}
}

proc dccscore { hand idx arg } { 
	variable dbcon
	if { $arg eq "" || [llength $arg] > 2 } {
		putdcc $idx ": .dicing score <> [].   '.help dicing score'";return
	}
	if { [::mysql::state $dbcon -numeric] < 2 } { if { ![initconnect] } { return } }
	set login [::mysql::escape $dbcon [lindex $arg 0]]	
	set q [::mysql::sel $dbcon "SELECT `id`, `score` FROM `users` WHERE `name`='$login'" -flatlist]
	if { ![llength $q] } {
		putdcc $idx " [lindex $arg 0]  "
		return
	}
	if { [lindex $arg 1] ne "" } {
		set scores [lindex $arg 1]
		if { ![isnumber $scores] || ( $scores < -1000000000 && $scores > 1000000000 ) } {
			putdcc $idx "        -1000000000  1000000000"
			return
		}
		::mysql::exec $dbcon "UPDATE `users` SET `score`='$scores' WHERE `id`='[lindex $q 0]'"
		putdcc $idx "  [lindex $arg 0]   $scores"
	} else {
		putdcc $idx "  [lindex $arg 0]: [lindex $q 1]"
	}
}

proc dccpass { hand idx arg } {
	variable dbcon
	if { $arg eq "" || [llength $arg] != 2 } { putdcc $idx ": .dicing pass <> <>.   '.help dicing pass'";return }
	set login [::mysql::escape $dbcon [lindex $arg 0]]
	set pass [md5 [lindex $arg 1]]
	if { [::mysql::state $dbcon -numeric] < 2 } { if { ![initconnect] } { return } }	
	set q [::mysql::sel $dbcon "SELECT `id` FROM `users` WHERE `name`='$login'" -flatlist]
	if { ![llength $q] } {
		putdcc $idx " [lindex $arg 0]  "
		return
	}
	::mysql::exec $dbcon "UPDATE `users` SET `pass`='$pass' WHERE `id`='[lindex $q 0]'"
	putdcc $idx "  [lindex $arg 0] ."
}

proc dccgive { hand idx arg } {
	dcctransfer $hand $idx 1 $arg
}

proc dcctake { hand idx arg } {
	dcctransfer $hand $idx 0 $arg
}

proc dcctransfer { hand idx act arg } {
	variable dbcon
	if { $arg eq "" || ([llength $arg] < 2 && [llength $arg] > 3)} { 
		putdcc $idx ": .dicing [expr $act?{give}:{take}] <> <> \[\]."
		putdcc $idx "  '.help dicing [expr $act?{give}:{take}]'"
		return
	}
	if { [::mysql::state $dbcon -numeric] < 2 } { if { ![initconnect] } { return } }		
	set login [::mysql::escape $dbcon [lindex $arg 0]]
	set cash [lindex $arg 1]
	set verbose 1
	if { [llength $arg] == 3 } {
		set verbose [expr [isnumber [lindex $arg 2]]?[lindex $arg 2]:1]
	}
	set q [::mysql::sel $dbcon "SELECT `id` FROM `users` WHERE `name`='$login'" -flatlist]
	if { ![llength $q] } {
		putdcc $idx " [lindex $arg 0]  ."
		return
	}
	
	if { ![isnumber $cash] } { 
		putdcc $idx "  ."
		return
	}	
	
	::mysql::exec $dbcon "UPDATE `users` SET `score`=`score`[expr $act?{+}:{-}]$cash WHERE `id`='$q'"
	putdcc $idx "  [lindex $arg 0] [expr $act?{}:{}]  $cash."
	if { [isonline [lindex $arg 0]] && $verbose } { 
		putserv "notice [getnickbylogin [lindex $arg 0]] :  [expr $act?{}:{}]  $cash."
	}
	return 
	
}